#include <iostream>
#include <sstream>

class cBinaryHeap
{
    private:
    protected:
    public:
        int m_Items[50];
        int m_itemCount;

        cBinaryHeap()
        {
            for(int i=0; i<50; i++)
                m_Items[i] = -1;

            m_itemCount = 0;
        }

        void Push(int Number)
        {
            //Add New Item
            m_itemCount++;
            m_Items[m_itemCount] = Number;

            //Bubble to top

            if(m_itemCount <= 1)
                return;

            bool Swap = true;
            int CurrentItem = m_itemCount;

            while(Swap)
            {
                Swap = false;

                //Get Parent Item
                int ParentIndex = 1;

                if(CurrentItem%2 == 0) //if even number
                    ParentIndex = CurrentItem/2;
                else
                    ParentIndex = (CurrentItem-1)/2;

                if(m_Items[ParentIndex] > m_Items[CurrentItem])
                {
                    //Swap
                    int tmpItem = m_Items[ParentIndex];
                    m_Items[ParentIndex] = m_Items[CurrentItem];
                    m_Items[CurrentItem] = tmpItem;

                    if(ParentIndex == 1) //If top item
                        return;

                    CurrentItem = ParentIndex;

                    Swap = true;

                    continue;
                }

                return;
            }

        }

        int Pop()
        {
            if(m_itemCount <= 0)
                return 0; //Empty

            int Number = m_Items[1]; //Get First Item

            m_Items[1] = m_Items[m_itemCount]; //Last To Front

            m_itemCount--;

            if(m_itemCount <= 1) //If no items, or last item
                return Number;

            //Sink to bottom

           int CurrentItem = 1;
           bool Swap = true;

           while(Swap)
           {
                Swap = false;
                int FirstChildIndex = CurrentItem * 2;
                int SecondChildIndex = (CurrentItem * 2) + 1;
                int LowestIndex = FirstChildIndex;

                //Check if second is lowest
                if(SecondChildIndex <=m_itemCount)
                    if(m_Items[SecondChildIndex] < m_Items[FirstChildIndex])
                        LowestIndex = SecondChildIndex;

               if(m_Items[CurrentItem] > m_Items[LowestIndex])
               {
                 //Swap
                 int TmpNumber = m_Items[LowestIndex];
                 m_Items[LowestIndex] = m_Items[CurrentItem];
                 m_Items[CurrentItem] = TmpNumber;

                 CurrentItem = LowestIndex;

                 //If has no further children then return
                 if((CurrentItem*2) > m_itemCount)
                    return Number;

                 Swap = true;
               }

               return Number;
           }
        }
};

int main(int argc, char *argv[])
{
    cBinaryHeap Heap;

    Heap.Push(5);
    Heap.Push(1);
    Heap.Push(53);
    Heap.Push(9);

    std::cout << Heap.Pop() << "\n"; //1
    std::cout << Heap.Pop() << "\n"; //5
    std::cout << Heap.Pop() << "\n"; //9
    std::cout << Heap.Pop() << "\n"; //53

    char key = 0;
	std::cin >> key;
    return 0;
}
