#include <iostream>
#include <sstream>

class cListItem
{
    private:
    public:

        cListItem *m_Next;
        cListItem *m_Previous;

        std::string MonitorName;

        cListItem();
};

cListItem::cListItem()
{
    m_Next = m_Previous = NULL;
}

void AddItem(cListItem* List, cListItem *Item)
{
    if(!List)
    {
        List = Item;
    }
    else
    {
        cListItem *NextItem = List;

        while(NextItem->m_Next)
            NextItem = NextItem->m_Next;

        NextItem->m_Next = Item;
    }
}

void RemoveItem(cListItem *Item)
{
    if(!Item)
        return;

    cListItem *PreviousItem = Item->m_Previous;
    cListItem *NextItem = Item->m_Next;

    delete Item;

    if(PreviousItem)
        PreviousItem->m_Next = NextItem;

    if(NextItem)
        NextItem->m_Previous = PreviousItem;
}

void ClearList(cListItem* List)
{
     cListItem *Item = List;

     while(Item)
     {
         cListItem *NextItem = Item->m_Next;

         delete Item;

         Item = NextItem;
     }
}

void PrintList(cListItem *List)
{
    if(List)
    {
        cListItem *NextItem = List;

        while(NextItem)
        {
            std::cout << NextItem->MonitorName + "\n";

            NextItem = NextItem->m_Next;
        }
    }
}

int main(int argc, char *argv[])
{
    cListItem *List = new cListItem();
    List->MonitorName = "0";



    //Fill the list
    for(int counter = 1; counter < 10; counter++)
    {
        std::string MonitorName = "";
        std::stringstream ss;

        ss << counter;
        ss >> MonitorName;

        cListItem *Item = new cListItem();

        Item->MonitorName = MonitorName;

        AddItem(List, Item);
    }

    PrintList(List);

    ClearList(List);

    char key = 0;
	std::cin >> key;
    return 0;
}
