#include <ClanLib/core.h>
#include <ClanLib/display.h>
#include <ClanLib/gl.h>
#include <ClanLib/application.h>

class cClanLibApp : public CL_ClanApplication {

public:
	cClanLibApp();
	~cClanLibApp();
	CL_Sprite* Sprite;
	CL_ResourceManager* Manager;

	//Render, draw Surface Objects here
	void UpdateFrames()
	{
        //Draw your stuff
        //EG. Surface->draw(0,0);

        Sprite->update();
        Sprite->draw(0,0);

	    return;
	}

	//Setup, create CL_Surface Objects here
	void Init()
	{
	    //Setup your stuff
	    //EG. CL_Surface *Surf = new CL_Surface("my_file.png");

        CL_ResourceManager* Manager = new CL_ResourceManager(resources.xml);
        Sprite = new CL_Sprite(my_sprite,  m_Manager);
        return;
	}

	virtual int main(int, char **)
	{
		CL_SetupCore setup_core;
		CL_SetupDisplay setup_display;
		CL_SetupGL setup_gl;
		CL_SetupSound setup_sound;

		CL_DisplayWindow window("Test", 640, 480);

		Init();

		//Enter game loop
		while (!CL_Keyboard::get_keycode(CL_KEY_ESCAPE))
		{
			CL_Display::clear(CL_Color(0, 0, 0, 255));
			UpdateFrames();
			CL_Display::flip();
			CL_System::sleep(10);
			CL_System::keep_alive();
		}

		return 0;
	}
}app;
