#include <ClanLib/core.h>
#include <ClanLib/display.h>
#include <ClanLib/gl.h>
#include <ClanLib/application.h>

class cClanLibApp : public CL_ClanApplication {

public:
	cClanLibApp();
	~cClanLibApp();

	CL_SceneManager* m_SceneManager;
	CL_ResourceManager* m_Manager;

	//Render, draw Surface Objects here
	void UpdateFrames()
	{
        //Draw your stuff
        //EG. Surface->draw(0,0);

        m_SceneManager->draw(0,0);

	    return;
	}

	//Setup, create CL_Surface Objects here
	void Init()
	{
	    //Setup your stuff
	    //EG. CL_Surface *Surf = new CL_Surface("my_file.png");

        //Create Scene Manager and Associate with a Resource Manager

        m_Manager = new CL_ResourceManager("resources.xml");

        CL_PixelBuffer Buffer = CL_PixelBuffer(512,512,512*4,CL_PixelFormat::rgba8888, NULL);

        m_SceneManager = new CL_SceneManager(Buffer, m_Manager);

        //createLayer(Width, height, PixelFormat, Pitch, Name)

        CL_SceneLayer *Layer1 = m_SceneManager->createLayer(256, 256, CL_PixelFormat::rgba8888, 256*4, "layer1");

        //Include sprite names
        CL_SceneObject *Sprite1 = m_SceneManager->createSceneObject("Game/Sprite01", m_Manager);
        CL_SceneObject *Sprite2 = m_SceneManager->createSceneObject("Game/Sprite02", m_Manager);

        Layer1->attachObject(Sprite1);

        Layer1->attachObject(Sprite2);

        m_SceneManager->addLayer(Layer1);

        return;
	}

	virtual int main(int, char **)
	{
		CL_SetupCore setup_core;
		CL_SetupDisplay setup_display;
		CL_SetupGL setup_gl;
		CL_SetupSound setup_sound;

		CL_DisplayWindow window("Test", 640, 480);


        m_SceneManager = NULL;
        m_Manager =  NULL;

        Init();

		//Enter game loop
		while (!CL_Keyboard::get_keycode(CL_KEY_ESCAPE))
		{
			CL_Display::clear(CL_Color(0, 0, 0, 255));
			UpdateFrames();
			CL_Display::flip();
			CL_System::sleep(10);
			CL_System::keep_alive();
		}

		return 0;
	}
}app;
