#ifndef header_scenelayer
#define header_scenelayer

class CL_SceneLayer : public CL_Surface
{
private:
	
	std::vector<CL_SceneObject*> m_Objects;
	CL_Canvas *m_Canvas; //Canvas to hold the composited pixel data
	bool m_bVisible;
	std::string m_Name;
	void *m_Data; //Custom Assoicated Data

	void composite(CL_Rect *Rect);

protected:
public:
	
	CL_Vector2 m_Position;

	CL_SceneLayer(CL_PixelBuffer Buffer, std::string Name = "");
	~CL_SceneLayer();

	void clearObjects();

	void attachObject(CL_SceneObject* Object) {m_Objects.push_back(Object);}
	void draw(float x = 0, float y = 0, CL_GraphicContext* context = 0);

	bool getVisible() {return m_bVisible;}
	void setVisible(bool Visible) {m_bVisible = Visible;}
	std::string getName() {return m_Name;}
	void setName(std::string Name) {m_Name = Name;}
	CL_Vector2* getPosition() {return &m_Position;}
	float getX() {return m_Position.x;}
	float getY() {return m_Position.y;}
	void setPosition(CL_Vector2 Position) {m_Position = Position;}
	void setPosition(float x, float y) {m_Position.x = x, m_Position.y = y;}
	std::vector<CL_SceneObject*> *getObjects() {return &m_Objects;}
	void* getData() {return m_Data;}
	void setData(void* Data) {m_Data = Data;}
};

#endif