#ifndef header_sceneobject
#define header_sceneobject

class CL_SceneObject : public CL_Sprite
{
private:

	CL_Vector2 m_Position;
	bool m_bVisible;
	std::string m_Name;
	void *m_Data; //Custom Assoicated Data
	
	void init(const std::string& resource_id, float x = 0, float y = 0, bool visible = true);

protected:
public:

	CL_SceneObject(const std::string& resource_id, CL_ResourceManager* manager, float x = 0, float y = 0, bool visible = true);
	CL_Vector2* getPosition() {return &m_Position;}
	float getX() {return m_Position.x;}
	float getY() {return m_Position.y;}
	void setPosition(CL_Vector2 Position) {m_Position = Position;}
	void setPosition(float x, float y) {m_Position.x = x, m_Position.y = y;}
	bool getVisible() {return m_bVisible;}
	void setVisible(bool Visible) {m_bVisible = Visible;}
	std::string getName() {return m_Name;}
	void* getData() {return m_Data;}
	void setData(void* Data) {m_Data = Data;}
};

#endif